<?php
/*
+---------------------------------------------------------------+
|	e107 website system
|
|	Steve Dunstan 2001-2002
|	http://e107.org
|	jalist@e107.org
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/

// Plugin info -------------------------------------------------------------------------------------------------------
$eplug_name = "Coppermine";
$eplug_version = "1.3";
$eplug_author = "McFly/MrPete";
$eplug_logo = "/images/cpg_icon.png";
$eplug_url = "";
$eplug_email = "mcfly@e107.org";
$eplug_description = "This plugin is an e107 integrated version of the Coppermine Photo Gallery (last I checked: v1.3.2)";
$eplug_compatible = "e107v6+";
$eplug_readme = "bridge/e107_readme.php";	// leave blank if no readme file

// Name of the plugin's folder -------------------------------------------------------------------------------------
$eplug_folder = "coppermine_menu";

// Name of menu item for plugin ----------------------------------------------------------------------------------
$eplug_menu_name = "coppermine_menu";

// User class for special users ---------------------------------------------------------------------------
$eplug_userclass = "COPPERMINE_ADMIN";

// Name of the admin configuration file --------------------------------------------------------------------------
$eplug_conffile = "e107config/config.php";

// Icon image and caption text ------------------------------------------------------------------------------------
$eplug_icon = "images/cpg_icon.png";
$eplug_caption =  "Configure Coppermine";

// List of preferences -----------------------------------------------------------------------------------------------

// List of sql requests to create tables -----------------------------------------------------------------------------
    require_once('include/sql_parse.php');
    $db_schema = 'sql/schema.sql';
    $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
    $db_basic = 'sql/basic.sql';
    $sql_query .= fread(fopen($db_basic, 'r'), filesize($db_basic));
    // Insert the admin account
//    $sql_query .= "INSERT INTO CPG_users VALUES (1, 1, 'YES', '" . $HTTP_POST_VARS['admin_username'] . "', '" . $HTTP_POST_VARS['admin_password'] . "', NOW(), NOW(), '', '', '', '', '', '', '');\n";
    // Set configuration values for image package
//    $sql_query .= "REPLACE INTO CPG_config VALUES ('thumb_method', '" . $HTTP_POST_VARS['thumb_method'] . "');\n";
//    $sql_query .= "REPLACE INTO CPG_config VALUES ('impath', '" . $HTTP_POST_VARS['impath'] . "');\n";
//    $sql_query .= "REPLACE INTO CPG_config VALUES ('ecards_more_pic_target', '" . $gallery_url_prefix . "');\n";
    // Test write permissions for main dir
    if (!is_writable('.')) {
        $sql_query .= "REPLACE INTO CPG_config VALUES ('default_dir_mode', '0777');\n";
        $sql_query .= "REPLACE INTO CPG_config VALUES ('default_file_mode', '0666');\n";
    }
    
    $sql_query = remove_remarks($sql_query);
    $sql_query = split_sql_file($sql_query, ';');

// List of table names -----------------------------------------------------------------------------------------------
// (Used for uninstall)
    $tablenames = array();
    while(list($key, $sql_req) = each($sql_query)){
    	$test=array();
    	if (preg_match('/CPG_(\w+)\W/',$sql_req,$test)) {
		$tablenames[] = 'CPG_'.$test[1];
 	}
    }
    $eplug_table_names = array_unique($tablenames);
    
// Now complete the process of creating SQL statements for installation    
// Update table prefix -- ok to do on array
    $sql_query = preg_replace('/CPG_/', $mySQLprefix.'CPG_', $sql_query);

    $eplug_tables = $sql_query;
//echo "sql is<br/>";
//print_r($sql_query);
//echo "<br/>";
// Create a link in main menu (yes=TRUE, no=FALSE) -------------------------------------------------------------
$eplug_link = TRUE;
$eplug_link_name = "Gallery";
$eplug_link_url = e_PLUGIN.$eplug_folder."/";


// Text to display after plugin successfully installed ------------------------------------------------------------------
$eplug_done = "
Coppermine is now installed.
<br /><br />
It should have created a link called 'Gallery' in your main menu.  As an admin, when you go
to a coppermine page it will automatically make sure you have the currect permissions
set in your directories.
<br /><br />
Please go to coppermine and fix any errors that are seen.
<br /><br />
Also, make sure that you create at least one album or you won't be able to do anything :)
";

// upgrading ... //

$upgrade_add_prefs = "";

$upgrade_remove_prefs = "";

    $db_update = 'sql/update.sql';
    $sql_query = fread(fopen($db_update, 'r'), filesize($db_update));
    // Update table prefix
    $sql_query = preg_replace('/CPG_/', $mySQLprefix.'CPG_', $sql_query);

    $sql_query = remove_remarks($sql_query);
    $sql_query = split_sql_file($sql_query, ';');

$upgrade_alter_tables = $sql_query;

$eplug_upgrade_done = "Upgrade has been completed successfully, you are now running version ".$eplug_version;

?>	